#include "xpm.h"
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/X.h>
#include <X11/cursorfont.h>
#include <X11/Xos.h>
#include <X11/keysym.h>

#ifndef general_h
#include "general.h"
#endif

#include "../source/bitmaps/icon_pixmap.xpm"
#include "../source/bitmaps/bomb.xpm"
#include "../source/bitmaps/goal.xpm"
#include "../source/bitmaps/bonus.xpm"
#include "../source/bitmaps/tree.xpm"
#include "../source/bitmaps/block.xpm"
#include "../source/bitmaps/unknown.xpm"
#include "../source/bitmaps/robotn.xpm"
#include "../source/bitmaps/robote.xpm"
#include "../source/bitmaps/robots.xpm"
#include "../source/bitmaps/robotw.xpm"
#include "../source/bitmaps/brobotn.xpm"
#include "../source/bitmaps/brobote.xpm"
#include "../source/bitmaps/brobots.xpm"
#include "../source/bitmaps/brobotw.xpm"
#include "../source/bitmaps/rocketn.xpm"
#include "../source/bitmaps/rockete.xpm"
#include "../source/bitmaps/rockets.xpm"
#include "../source/bitmaps/rocketw.xpm"
#include "../source/bitmaps/explosion_0.xpm"
#include "../source/bitmaps/explosion_1.xpm"
#include "../source/bitmaps/explosion_2.xpm"
#include "../source/bitmaps/explosion_3.xpm"
#include "../source/bitmaps/explosion_4.xpm"
#include "../source/bitmaps/explosion_5.xpm"
#include "../source/bitmaps/bg_green.xpm"
#include "../source/bitmaps/bg_desert.xpm"
#include "../source/bitmaps/bg_red.xpm"
#include "../source/bitmaps/bg_gray.xpm"
#include "../source/bitmaps/one.xpm"
#include "../source/bitmaps/two.xpm"
#include "../source/bitmaps/three.xpm"
#include "../source/bitmaps/four.xpm"
#include "../source/bitmaps/five.xpm"
#include "../source/bitmaps/six.xpm"
#include "../source/bitmaps/seven.xpm"
#include "../source/bitmaps/eight.xpm"
#include "../source/bitmaps/nine.xpm"
#include "../source/bitmaps/ten.xpm"

/* Some definitions for the X Windows. */
#define MENU_HEIGHT 54
#define IMAGEX 40 /* Image dimensions of robots, bombs etc - pixels. */
#define IMAGEY 40
#define BORDER 2
#define STATUS_WIDTH (4*IMAGEX) /* Try to ensure STATUS_WIDTH is 1/10th FIELDX. */
#define CONTROL_WIDTH (2*IMAGEX-BORDER) 
#define CONTROL_HEIGHT IMAGEX

/* Radar field typically 1/10th scale of battlefield. Aspect ratio is 4 : 3. */
#define RADAR_WIDTH (4*IMAGEX)
#define RADAR_HEIGHT (3*IMAGEY)
#define STATUS_HEIGHT ((MAXY*IMAGEY)-(6*BORDER+2*CONTROL_HEIGHT)-(RADAR_HEIGHT))

/* Pixel dimensions of scaled radar images. */
#define RADAR_X (int)((double) RADAR_WIDTH/FIELDX)
#define RADAR_Y (int)((double) RADAR_HEIGHT/FIELDY)

static char *colorNames[] = {
  "black",
  "white",
  "antique white",
  "orange", 
  "red",
  "blue",
  "light steel blue",
  "green3",
  "green",
  "light yellow",
  "yellow",
  "hot pink"
};

#define NUM_OF_COLORS   (sizeof(colorNames) / sizeof(char *))
#define NUM_SECTORS 4
#define NUMBERS 10
#define EXP_FRAMES 6

Display *Disp;
Colormap colormap;
unsigned long colorPixelValues[NUM_OF_COLORS];
int Scr;
Window Win,FWin,Root;             /* Field Window = FWin. */
Window CWin1, CWin2, CWin3;	  /* Control Windows (Start/Stop/Pause). */ 
Window RWin;                      /* Radar/Sector Window. */
XEvent report;
XFontStruct *font_info;
Pixmap target, bomb, bonus, tree, block, unknown; 
Pixmap rocket[FULL_ROTATION];
Pixmap robot[FULL_ROTATION];
Pixmap brobot[FULL_ROTATION];
Pixmap Exp[EXP_FRAMES];
Pixmap bomb_mask, bonus_mask, tree_mask, block_mask, unknown_mask; 
Pixmap rocket_mask[FULL_ROTATION];
Pixmap robot_mask[FULL_ROTATION];
Pixmap exp_mask[EXP_FRAMES];
Pixmap num[NUMBERS];
Pixmap bg[NUM_SECTORS]; /* Backdrop scenes. */
Pixmap num_mask;

GC GcB;     /* Background. */
GC GcGRF;   /* Good Robot Foreground. */
GC GcBRF;   /* Bad Robot Foreground. */
GC GcEF;    /* Explosion Foreground. */
GC GcDF;    /* Default Foreground. */
GC GcPF;    /* Positive (bonus) Foreground. */
GC GcNF;    /* Negative (bomb) Foreground. */
GC GcGF;    /* Goal (target) Foreground. */
GC GcTF;    /* Text Foreground. */
GC GcSector;/* Hilight for active sector in radar window. */

/* The following GC's are specific to the battlefield and related pixmaps.
   Having these extra GC's allows pixmap-specific clipmasks to be created once
   only and used again and again. */

GC GcBattle[NUM_SECTORS];/* Battlefield scene GCs. */
GC GcBomb;
GC GcBonus, GcUnknown;
GC GcRobot[FULL_ROTATION];
GC GcRocket[FULL_ROTATION];
GC GcExp[EXP_FRAMES];
GC GcNum;
GC GcBlock;
GC GcTree;








